import java.net.*;
import java.net.http.*;
import java.time.*;
import java.nio.file.*;


public class Http2Access{

  public static void main(String[] args) throws Exception{
    var client = HttpClient.newBuilder()
                           .version(HttpClient.Version.HTTP_2)
                           .followRedirects(HttpClient.Redirect.NORMAL)
                           .build();
    var uri = new URI("https", "gihyo.jp", "/", null);
    var request = HttpRequest.newBuilder(uri)
                             .GET()
                             .timeout(Duration.ofSeconds(30))
                             .build();

    var response = client.send(request, HttpResponse.BodyHandlers.ofString());
    System.out.println(response.body());

    //client.send(request, HttpResponse.BodyHandlers.ofFileDownload(Paths.get(".")));
    //client.send(request, HttpResponse.BodyHandlers.ofFile(Paths.get("download.dat")));
  }

}
